
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <SD.h>
#include <Adafruit_TSL2591.h>
#include <millisDelay.h>
#include <SoftwareSerial.h>
#include "RTClib.h"

RTC_PCF8523 rtc; //type rtc
SoftwareSerial BTserial(15, 14); // RX | TX


Adafruit_TSL2591 tsl = Adafruit_TSL2591(2591);
millisDelay MeasureDelay;

  const int OutputPump = 32;
  const int InputPump = 45;
  const int KHTitrantPump =28;
  const int Timefill=400;
  const int KHIndPump = 43;
  const int KHPlusPump = 41;
  const int CaPlusPump = 38;
  const int NaClFreePump = 39;
  const int Roerder = 36;
  const int MaxWaste = 48;
  const int Led=40;
  const int Direction_KH_Pump = 25;
  const int FG_KH_Pump = 23;
  const int PWM_HCL = 8;
  
  int Lightstability =500;
  int Roer=1000;// roertijd na titratietoevoeging
  bool EP=false ;
  

  long Light[255]; // waarden tussen 0 en 255 voor lichtmetingen KH bepaling
  long Volume[255]; //waarden tussen 0 en 255 volumemetingen tijden KH bepaling
  long EesteAfgeleide_Light[254];
  long EesteAfgeleide_Volume[254];
  long TweedeAfgeleide_Light[253];
  
  
  unsigned long KH=8;
  unsigned long blanco=0;
  unsigned long HCLindicator=0;
  int x=1;
 
  // max length of received command is 20 chrs not including the \0 character
  
const byte numChars = 21;
char receivedChars[numChars];
boolean newData = false; 
boolean Tijd_Aan = false;
int Tijd =1000;

File logfile;

void error(char *str)
{
  Serial.print("error: ");
  Serial.println(str);
  
  while(1);
}

void setup() {

  Serial.begin(9600);
  BTserial.begin(9600);
  BTserial.setTimeout (2000);
  BTserial.println("Hello from Arduino via Bluetooth");
  while (BTserial.available()) { BTserial.read(); }
  
  while (!BTserial) {
    Serial.println("wachten op bluetooth serial");
    delay(100);// wait for serial port to connect. Needed for native USB
  }
  Serial.println("bluetooth is aan");
  pinMode(OutputPump,OUTPUT);//pomp extractie
  pinMode(InputPump,OUTPUT);//pomp toevoer
  pinMode(KHIndPump,OUTPUT);//pomp KH indicator
  pinMode(KHTitrantPump,OUTPUT);//hcltoevoer
  pinMode(KHPlusPump,OUTPUT);//pomp toevoer KH plus aansturing
  pinMode(CaPlusPump,OUTPUT);//pomp Calciumdichloride dihydraat aansturing
  pinMode(NaClFreePump,OUTPUT);//pomp nacl vrij zout aansturing
  pinMode(Roerder,OUTPUT);//pomp aansturing
  pinMode(Led,OUTPUT);// verlichting aansturing
  pinMode(MaxWaste,INPUT);//overvul beveiliging afval  
  pinMode(Direction_KH_Pump,OUTPUT);
  pinMode(FG_KH_Pump,INPUT);
  pinMode(PWM_HCL,OUTPUT);
  
  
  


  
 //lichtsensor  
  if (tsl.begin()) 
  {
 Serial.print("Found a TSL2591");
 BTserial.println("Found a TSL2591");
 Serial.println("sensor");
 BTserial.println("SENSOR AAN");
  } 
  else 
  {
  Serial.println("No sensor found"); 
  Serial.println(("Check your wiring"));
  BTserial.println("SENSOR ERROR");
    while (1);
  }
  delay(100);
   tsl.setGain(TSL2591_GAIN_LOW);    // 1x gain (bright light)
  //tsl.setGain(TSL2591_GAIN_MED);      // 25x gain
  //tsl.setGain(TSL2591_GAIN_HIGH);   // 428x gain
  
  //tsl.setTiming(TSL2591_INTEGRATIONTIME_100MS);  // shortest integration time (bright light)
  //tsl.setTiming(TSL2591_INTEGRATIONTIME_200MS);
  //tsl.setTiming(TSL2591_INTEGRATIONTIME_300MS);
  tsl.setTiming(TSL2591_INTEGRATIONTIME_400MS);
  //tsl.setTiming(TSL2591_INTEGRATIONTIME_500MS);
  //tsl.setTiming(TSL2591_INTEGRATIONTIME_600MS);  // longest integration time (dim light)

  // einde code voor lichtsensor

  //meet Delay start
   
Serial.println("pomp test start");
BTserial.println("pomp test start");

digitalWrite(OutputPump,HIGH);
Serial.println("output pomp");
BTserial.println("output pomp");
delay (5000);
digitalWrite(OutputPump,LOW);

digitalWrite(InputPump,HIGH);
Serial.println("in pomp");
BTserial.println("in pomp");
delay (2000);
digitalWrite(InputPump,LOW);

digitalWrite(KHIndPump,HIGH);
Serial.println("indicator pomp");
BTserial.println("indicator pomp");
delay (2000);
digitalWrite(KHIndPump,LOW);

analogWrite(PWM_HCL,0);
digitalWrite(Direction_KH_Pump,HIGH);
digitalWrite(KHTitrantPump,HIGH);
Serial.println("HCl pomp");
BTserial.println("HCl pomp");
delay (2000);
digitalWrite(KHTitrantPump,LOW);

digitalWrite(KHPlusPump,HIGH);
Serial.println("KH+ pomp");
BTserial.println("KH+ pomp");
delay (2000);
digitalWrite(KHPlusPump,LOW);

digitalWrite(CaPlusPump,HIGH);
Serial.println("Ca+ pomp");
BTserial.println("Ca+ pomp");
delay (2000);
digitalWrite(CaPlusPump,LOW);

digitalWrite(NaClFreePump,HIGH);
Serial.println("NaClfree pomp");
BTserial.println("NaClfree pomp");
delay (2000);
digitalWrite(NaClFreePump,LOW);

digitalWrite(Roerder,HIGH);
Serial.println("roerder");
BTserial.println("ROERDER");
delay (2000);
digitalWrite(Roerder,LOW);

digitalWrite(Led,HIGH);
Serial.println("Verlichting");
BTserial.println("Verlichting");
delay (5000);                                                                 
digitalWrite(Led,LOW);


}

void Test_KH()
{
   unsigned long mean=0;
   unsigned int counter=0;
   
  //leegpompen
  Serial.println("Testmeting van KH");
  Serial.print("leegpompen");
  digitalWrite(OutputPump,HIGH);   //pump aan
  delay(10000);
  digitalWrite(OutputPump,LOW);    //Pump uit

  //voorspoelen
  digitalWrite(InputPump,HIGH);   //pump aan
  delay(5000);
  digitalWrite(InputPump,LOW);    //Pump uit  
  
   //leegpompen 2
  digitalWrite(OutputPump,HIGH);   //pump aan
  delay(10000);
  digitalWrite(OutputPump,LOW);    //Pump uit
   
   
   //vullen van reactor
   Serial.print("vullen");
   digitalWrite(InputPump,HIGH);   //pump aan
   delay(10000);
   digitalWrite(InputPump,LOW);    //Pump uit

   digitalWrite(Roerder,HIGH);  //roerder aan 
   digitalWrite(Led,HIGH);  // led aanzetten

   // indicator toevoegen
   digitalWrite(KHIndPump,HIGH);   //pump aan
   delay(1000);
   digitalWrite(KHIndPump,LOW);    //Pump uit

   Serial.println ("mengen");
   delay(5000);
   
   //roerder uit
    digitalWrite(Roerder,LOW);
    
   // eerste meetwaarde zonder titrant
   
   Serial.println("Eeste meting:");
   delay(1000);// beweging in vloeistof stil
   
   do {
      uint32_t x = tsl.getFullLuminosity();
      counter++;
      mean=mean+x;      
      }
   while( counter<20);
     
  mean= mean/20;
  blanco = mean;
  mean=0;
  Light[0]=blanco;
  Volume[0]=0;
    
  Serial.print("testoplossing met indicator:");
  Serial.print (" gem:");
  Serial.println (blanco);
  BTserial.println(blanco); 
  Serial.println(" start met loop van titratie:");

  for(byte i=1;i<140;i++)
  {
    if (i=1)
    {
  digitalWrite(KHTitrantPump,HIGH);   //pump aan
  delay(Timefill);
  digitalWrite(KHTitrantPump,LOW);    //Pump uit
  Volume[i]=Volume[i-1]+Timefill;
  
  delay(Roer);// roertijd
  digitalWrite(Roerder,LOW);
  delay(1000);// beweging in vloeistof stil
  
  do {
      uint32_t x = tsl.getFullLuminosity();
      counter++;
      mean=mean+x;      
      }
  while( counter<20);
     
  mean= mean/20;
  
  HCLindicator = mean;
  mean=0;
  Light[i]=HCLindicator;
  BTserial.println(HCLindicator); 
  
  digitalWrite(Roerder,HIGH);
    }
   
  }
     //roerder uit
  digitalWrite(Roerder,LOW);
    // led uit
  digitalWrite(Led,LOW);  

    //leegpompen
  
  digitalWrite(OutputPump,HIGH);   //pump aan
  delay(40000);
  digitalWrite(OutputPump,LOW);    //Pump uit
  Serial.println("einde");
  
}

void Measurement_KH()
{
   unsigned long mean=0;
   unsigned int counter=0;
   
  //leegpompen
  Serial.println("Meten van KH");
  Serial.print("leegpompen");
  digitalWrite(OutputPump,HIGH);   //pump aan
  delay(10000);
  digitalWrite(OutputPump,LOW);    //Pump uit

  //voorspoelen
  digitalWrite(InputPump,HIGH);   //pump aan
  delay(5000);
  digitalWrite(InputPump,LOW);    //Pump uit  
  
   //leegpompen 2
  digitalWrite(OutputPump,HIGH);   //pump aan
  delay(10000);
  digitalWrite(OutputPump,LOW);    //Pump uit
   
   
   //vullen van reactor
   Serial.print("vullen");
   digitalWrite(InputPump,HIGH);   //pump aan
   delay(10000);
   digitalWrite(InputPump,LOW);    //Pump uit

   //roerder aan  

   digitalWrite(Roerder,HIGH);   

   // led aanzetten
   digitalWrite(Led,HIGH);  

   // indicator toevoegen
   digitalWrite(KHIndPump,HIGH);   //pump aan
   delay(1000);
   digitalWrite(KHIndPump,LOW);    //Pump uit

   Serial.println ("mengen");
   delay(5000);
   
   //roerder uit
    digitalWrite(Roerder,LOW);
    
   // eerste meetwaarde zonder titrant
   
   Serial.println("Eeste meting:");
   delay(1000);// beweging in vloeistof stil
   
   do {
      uint32_t x = tsl.getFullLuminosity();
      counter++;
      mean=mean+x;      
      }
   while( counter<20);
     
  mean= mean/20;
  
  blanco = mean;
  mean=0;

  Light[0]=blanco;
  Volume[0]=0;
    
  Serial.print("testoplossing met indicator:");
  Serial.print (" gem:");
  Serial.println (blanco); 
   
  Serial.println(" start met loop van titratie:");

  for(byte i=1;i<255;i++)
  {
    if (i=1)
    {
  digitalWrite(KHTitrantPump,HIGH);   //pump aan
  delay(Timefill);
  digitalWrite(KHTitrantPump,LOW);    //Pump uit
  Volume[1]=Timefill;
  
  delay(Roer);// roertijd
  digitalWrite(Roerder,LOW);
  delay(1000);// beweging in vloeistof stil
  
  do {
      uint32_t x = tsl.getFullLuminosity();
      counter++;
      mean=mean+x;      
      }
  while( counter<20);
     
  mean= mean/20;
  
  HCLindicator = mean;
  mean=0;
  Light[1]=HCLindicator;
  
  digitalWrite(Roerder,HIGH);
    }

  if((Light[i-1]-Light[i-2])>Lightstability)
  {
    digitalWrite(KHTitrantPump,HIGH);   //pump aan
    delay(Timefill);
    digitalWrite(KHTitrantPump,LOW);    //Pump uit
    Volume[i]=Timefill+Volume[i-1];
    
    delay(Roer);// roertijd
    digitalWrite(Roerder,LOW);
    delay(1000);// beweging in vloeistof stil
      do {
        uint32_t x = tsl.getFullLuminosity();
        counter++;
        mean=mean+x;      
        }
      while( counter<20);
     
    mean= mean/20;
  
    HCLindicator = mean;
    mean=0;
    Light[i]=HCLindicator;
    digitalWrite(Roerder,HIGH);
    EP=true; 
    
  }
  if((Light[i-1]-Light[i-2])<Lightstability)
  {
    digitalWrite(KHTitrantPump,HIGH);   //pump aan
    delay((Volume[i-1]-Volume[i-2])*2);
    digitalWrite(KHTitrantPump,LOW);    //Pump uit
    Volume[i]=(((Volume[i-1]-Volume[i-2]))*2+Volume[i-1]);
    
    delay(Roer);// roertijd
    
    digitalWrite(Roerder,LOW);
    delay(1000);// beweging in vloeistof stil
    
      do {
        uint32_t x = tsl.getFullLuminosity();
        counter++;
        mean=mean+x;      
        }
      while( counter<20);
     
    mean= mean/20;
  
    HCLindicator = mean;
    mean=0;
    Light[i]=HCLindicator;
    digitalWrite(Roerder,HIGH);
   }
  if(EP==true & (Light[i-1]-Light[i-2])<Lightstability & (Volume[i]-Volume[i-1])>4*Timefill)
  {
    i=255;
    Serial.println ("Exit loop titratie");
  
  }
   
  }
  
  
     //roerder uit
    digitalWrite(Roerder,LOW);
    // led uit
    digitalWrite(Led,LOW);  

    //leegpompen
  
  digitalWrite(OutputPump,HIGH);   //pump aan
  delay(40000);
  digitalWrite(OutputPump,LOW);    //Pump uit
  Serial.println("einde");
  EP=false;
  
}


 

void recvWithStartEndMarkers() 
{
     static boolean recvInProgress = false;
     static byte ndx = 0;
     char startMarker = '[';
     char endMarker = ']';
 
     char rc;
 
     if (BTserial.available() > 0) 
     {
          Serial.println(BTserial.read());
          rc = BTserial.read();
          if (recvInProgress == true) 
          {
               if (rc != endMarker) 
               {
                    receivedChars[ndx] = rc;
                    ndx++;
                    if (ndx >= numChars) { ndx = numChars - 1; }
               }
               else 
               {
                     Serial.println(receivedChars);
                     receivedChars[ndx] = '\0'; // terminate the string
                     recvInProgress = false;
                     ndx = 0;
                     newData = true;
               }
          }
          else if (rc == startMarker) { recvInProgress = true; }
     }
      if (Serial.available() > 0) 
     {
          
          rc = Serial.read();
          if (recvInProgress == true) 
          {
               if (rc != endMarker) 
               {
                    receivedChars[ndx] = rc;
                    ndx++;
                    if (ndx >= numChars) { ndx = numChars - 1; }
               }
               else 
               {
                     receivedChars[ndx] = '\0'; // terminate the string
                     recvInProgress = false;
                     ndx = 0;
                     newData = true;
               }
          }
          else if (rc == startMarker) { recvInProgress = true; }
     }
}



 void manueel()
 {
  if(Tijd_Aan==false)
  {   
  
  if (strcmp(receivedChars,"KH+1")==0)
 {
  digitalWrite(KHPlusPump,HIGH); 
  memset(receivedChars,0,21); 
  }
  if (strcmp(receivedChars,"KH+0")==0)
 {
  digitalWrite(KHPlusPump,LOW); 
  memset(receivedChars,0,21); 
  }
  if(strcmp(receivedChars,"CA+1")==0)
{
  digitalWrite(CaPlusPump,HIGH); 
  memset(receivedChars,0,21); 
}   
  if(strcmp(receivedChars,"CA+0")==0)
{
  digitalWrite(CaPlusPump,LOW); 
  memset(receivedChars,0,21); 
}   
 if(strcmp(receivedChars,"NaCl+1")==0)
{
  digitalWrite(NaClFreePump,HIGH);
  memset(receivedChars,0,21);  
} 
 if(strcmp(receivedChars,"NaCl+0")==0)
{
  digitalWrite(NaClFreePump,LOW); 
  memset(receivedChars,0,21);  
} 
 if(strcmp(receivedChars,"IndKH1")==0)
{
  digitalWrite(KHIndPump,HIGH);
  memset(receivedChars,0,21); 
} 
 if(strcmp(receivedChars,"IndKH0")==0)
{
  digitalWrite(KHIndPump,LOW); 
  memset(receivedChars,0,21); 
} 
 if(strcmp(receivedChars,"TitrHCl1")==0)
{
  digitalWrite(KHTitrantPump,HIGH); 
  memset(receivedChars,0,21); 
} 
 if(strcmp(receivedChars,"TitrHCl0")==0)
{
  digitalWrite(KHTitrantPump,LOW); 
  memset(receivedChars,0,21); 
} 
 if(strcmp(receivedChars,"Out1")==0)
{
  digitalWrite(OutputPump,HIGH);
  memset(receivedChars,0,21); 
}
 if(strcmp(receivedChars,"Out0")==0)
{
  digitalWrite(OutputPump,LOW); 
  memset(receivedChars,0,21); 
}
 if(strcmp(receivedChars,"In1")==0)
{
  digitalWrite(InputPump,HIGH);
  memset(receivedChars,0,21);  
}
 if(strcmp(receivedChars,"In0")==0)
{
  digitalWrite(InputPump,LOW); 
  memset(receivedChars,0,21);  
}
if(strcmp(receivedChars,"Licht0")==0)
{
  digitalWrite(Led,LOW); 
  memset(receivedChars,0,21);  
}
if(strcmp(receivedChars,"Licht1")==0)
{
  digitalWrite(Led,HIGH);  
  memset(receivedChars,0,21);  
}
if(strcmp(receivedChars,"Roerder0")==0)
{
  digitalWrite(Roerder,LOW); 
  memset(receivedChars,0,21);  
}
if(strcmp(receivedChars,"Roerder1")==0)
{
  digitalWrite(Roerder,HIGH); 
  memset(receivedChars,0,21);  
}                                                                                         
  }
  else 
  {
 if (strcmp(receivedChars,"KH+1")==0)
 {
  digitalWrite(KHPlusPump,HIGH); 
  delay(Tijd);
  digitalWrite(KHPlusPump,LOW); 
  memset(receivedChars,0,21); 
  }
  if(strcmp(receivedChars,"CA+1")==0)
{
  digitalWrite(CaPlusPump,HIGH); 
  delay(Tijd);
  digitalWrite(CaPlusPump,LOW); 
  memset(receivedChars,0,21); 
}   
 if(strcmp(receivedChars,"NaCl+1")==0)
{
  digitalWrite(NaClFreePump,HIGH); 
  delay(Tijd);
  digitalWrite(NaClFreePump,LOW); 
  memset(receivedChars,0,21);  
} 
 if(strcmp(receivedChars,"IndKH1")==0)
{
  digitalWrite(KHIndPump,HIGH); 
  delay(Tijd);
  digitalWrite(KHIndPump,LOW); 
  memset(receivedChars,0,21); 
} 
 if(strcmp(receivedChars,"TitrHCl1")==0)
{
  digitalWrite(KHTitrantPump,HIGH); 
  delay(Tijd);
  digitalWrite(KHTitrantPump,LOW); 
  memset(receivedChars,0,21); 
} 
 if(strcmp(receivedChars,"Out1")==0)
{
  digitalWrite(OutputPump,HIGH); 
  delay(Tijd);
  digitalWrite(OutputPump,LOW); 
  memset(receivedChars,0,21); 
}
 if(strcmp(receivedChars,"In1")==0)
{
  digitalWrite(InputPump,HIGH); 
  delay(Tijd);
  digitalWrite(InputPump,LOW); 
  memset(receivedChars,0,21);  
}
if(strcmp(receivedChars,"Licht0")==0)
{
  digitalWrite(Led,LOW); 
  memset(receivedChars,0,21);  
}
if(strcmp(receivedChars,"Licht1")==0)
{
  digitalWrite(Led,HIGH);  
  memset(receivedChars,0,21);  
}
if(strcmp(receivedChars,"Roerder0")==0)
{
  digitalWrite(Roerder,LOW); 
  memset(receivedChars,0,21);  
}
if(strcmp(receivedChars,"Roerder1")==0)
{
  digitalWrite(Roerder,HIGH); 
  memset(receivedChars,0,21);  
}                     
  }
 }
 


void loop()
{

   
    if (BTserial.available() > 0)     {  
      
      Serial.println("BTserial is actief in loop");
      
      recvWithStartEndMarkers();
      }
if (Serial.available() > 0)     {  
  Serial.println("Serial is actief");
      
      recvWithStartEndMarkers();
      
      }

    if(strcmp(receivedChars,"Smartphone")==0)
    {
      Serial.println("smartphone is aangesloten"); //nu staat menu overview klaar
      memset(receivedChars,0,21);
    }
    if(strcmp(receivedChars,"StartTest")==0)
    {
      Serial.println("Testkh start");
      memset(receivedChars,0,21);
      Test_KH();
    }
    
    if(strcmp(receivedChars,"Tijd0")==0)
    {
      Tijd_Aan=false;
      memset (receivedChars,0,21);
    } 
    if(strcmp(receivedChars,"Tijd1")==0)
    {
      Tijd_Aan=true;
      memset(receivedChars,0,21);
    }
    
    manueel();

    
    
}
